/******************************/
/********* FLUIDSOFT **********/
/******************************/
/*
	Copyright @ Fluidsoft
*/
var languageUser = "";
var lastDispositivo = ["", ""];
var statoMacchinaLingua = [];
var alertLingua = [];
var customerCode = "746318";
var token = "";
var tipoStufa;
var statoGetDevice = 0;

var urlMicronova = "http://wifi.micronovasrl.com/WiFiMi/WiFiMiRestWebService.svc/xml";
var urlMCZ = "https://www.mczgroup.com/getToken/customerCode/746318";

document.addEventListener("deviceready", readPersonalData, false); //Inizio leggendo la lista dei dispositivi
document.addEventListener("backbutton", onBackKeyDown, false);

function onBackKeyDown() {
    var r = confirm( alertLingua[0] );
    if (r == true)
        {navigator.app.exitApp();} 
}

function erroreConnessione(testo, disabilitoMenu)
        {
            $(".div-alert .text").html( testo ).fadeIn(500);
            if( disabilitoMenu == 1 )
                {
                    $('#sub-stato .button-on-off .accensione').addClass("disabled");
                    $(".footer a#stato").trigger("click");
                    $('.footer a').addClass("disabled");
                }
            else
                {$(".div-alert .text").fadeOut(4000);}
        }

function cambiaPotenza(valore)
{
    $("#sub-potenza .seleziona-potenza .potenze").attr("value", valore);
    $("#sub-potenza .potenze .center .rect").css({"background-color" : "#d4d9df"});
    for(i = $("#sub-potenza .seleziona-potenza .potenze").attr("min"); i <= valore; i++)
        {$("#sub-potenza .potenze .center #r" + i).css({"background-color" : "#7d7d7d"});} 
}

function cambiaVentilazione(min, max, value, auto, enabled, off, ventilatore)
{
    if( enabled == "1" )
        {$("#sub-ventilazione ." + ventilatore).addClass("enabled");}

    $("#sub-ventilazione ." + ventilatore).attr("min", min);
    $("#sub-ventilazione ." + ventilatore).attr("max", max);
    $("#sub-ventilazione ." + ventilatore).attr("value", value);
    $("#sub-ventilazione ." + ventilatore).attr("auto", auto);
    $("#sub-ventilazione ." + ventilatore).attr("off", off);
    
    $("#sub-ventilazione ." + ventilatore + " .rect").css({"background-color" : "#d4d9df"});
    for(i = min; i <= value; i++)
        {$("#sub-ventilazione ." + ventilatore + " #r" + i).css({"background-color" : "#7d7d7d"});}
    
    if( auto == value && auto != 255 )
        {$("#sub-ventilazione ." + ventilatore + " .auto-div").css({"display" : "block"});} 
    else
        {$("#sub-ventilazione ." + ventilatore + " .auto-div").css({"display" : "none"});}
    
    if( off == value && off != 255 )
        {$("#sub-ventilazione ." + ventilatore + " .off-div").css({"display" : "block"});} 
    else
        {$("#sub-ventilazione ." + ventilatore + " .off-div").css({"display" : "none"});}
}

function getToken(nomeFunzione, indice, valore)
{   
    token = "";
    $.ajax({
        type: "GET",
        url: urlMCZ,
        dataType: "xml",
        cache: false
    }).done(function( xml ) {
        $getData = $(xml).find( "token" );
        var risultato = $getData.text().trim();
        token = risultato;
        $(".token-read").html(token);
        
        if( nomeFunzione == "getState" )
            {getState();}
        else if( nomeFunzione == "getDeviceInfo" )
            {getDeviceInfo();}
        else if( nomeFunzione == "writeParameter" )
            {writeParameter(indice, valore);}
        else if( nomeFunzione == "registerDevice" )
            {registerDevice( $("#sub-registra-prodotto .mac-address input").val(), $("#sub-registra-prodotto .codice-wifi input").val(), $("#sub-registra-prodotto .codice-articolo input").val(), "", $("#sub-registra-prodotto .nome-prodotto input").val() );}
        else if( nomeFunzione == "readChrono" )
            {readChrono();}
        else if( nomeFunzione == "writeChrono" )
            {writeChrono();}
        
    }).fail(function( xml ) {
        erroreConnessione(alertLingua[10] + "<br />Code: TK1", 1);
        getStateTimeNext = 8000;
    });
}

function writeParameter(indice, valore)
{
    $.ajax({
        type: "GET",
        url: urlMicronova + "/WriteParameter/" + customerCode + "|" + token + "|" + lastDispositivo[0] + "|" + indice + "|" + valore,
        dataType: "xml",
        cache: false
    }).done(function( xml ) {

        if(risultato == "65")
            {erroreConnessione(alertLingua[16], 0);}
        else if(risultato == "73")
            {erroreConnessione(alertLingua[12], 0);}
        else if(risultato == "74")
            {erroreConnessione(alertLingua[13], 0);}
        
    }).fail(function( xml ) {
        erroreConnessione(alertLingua[10], 0);
    });
}

function getState()
{   
    $.ajax({
        type: "GET",
        //url: "https://www.mczgroup.com/getToken/customerCode/746318",
        url: urlMicronova + "/GetState/" + customerCode + "|" + token + "|" + lastDispositivo[0],
        dataType: "xml",
        cache: false
    }).done(function( xml ) {
            $getData = $(xml).find( "GetStateResult" );
            var risultato = $getData.text().trim();
            //var risultato = "00161E001E04FF01FF050000000005FFFF010103010506FF010103000606FF000000FFFF0101";
            $(".getstate-read").html(risultato);
            if(risultato == "65")
                {erroreConnessione(alertLingua[16], 1); getStateTimeNext = 8000;}
            else if(risultato == "5E")
                {erroreConnessione(alertLingua[16], 1); getStateTimeNext = 8000;}
            else if(risultato == "5D")
                {erroreConnessione(alertLingua[16], 1); getStateTimeNext = 8000;}
            else if(risultato.length > 20) //Se ricevo una stringa con più di 20 caratteri
            {
            getStateTimeNext = 18000;
            $(".div-alert .text").fadeOut(500);
            $('.footer a').removeClass("disabled");
            $('#sub-stato .button-on-off .accensione').removeClass("disabled");
            var arrayStringa = [];
                for(var i = 0; i < risultato.length; i++)
                {
                    arrayStringa[i/2] = parseInt(risultato.substring(i, i + 2), 16);
                    i++;
                }
            
            /****** STATO PAGE *******/
            if( arrayStringa[0] == "0" )
                {$("#sub-stato .button-on-off img").attr( "src", "images/off.png" ).attr("value", 0);}
            else
                {$("#sub-stato .button-on-off img").attr( "src", "images/on.png" ).attr("value", 1);}
            
            if( arrayStringa[37] == "0" )
                {$("#sub-stato .lista-stato .stato .right").html("AUTO");}
            else if( arrayStringa[0] == "4" /*|| arrayStringa[0] == "5"*/ )
                {$("#sub-stato .lista-stato .stato .right").html( statoMacchinaLingua[arrayStringa[0]] + " " + arrayStringa[5] ); }
            else
                {$("#sub-stato .lista-stato .stato .right").html( statoMacchinaLingua[arrayStringa[0]] );}
                
            if( arrayStringa[36] == "1" )
                {$("#sub-stato .eco-stop .right").html( "ON" ).removeClass( "hidden" );}
            else if( arrayStringa[36] == "0" )
                {$("#sub-stato .eco-stop .right").html( "OFF" ).removeClass( "hidden" );}
            else if( arrayStringa[36] == "255" )
                {$("#sub-stato .eco-stop").addClass( "hidden" );}
                
            if( arrayStringa[37] == "1" )
                {$("#sub-stato .auto-mode .right").html( "OFF" ).removeClass( "hidden" );}
            else if( arrayStringa[37] == "0" )
                {$("#sub-stato .auto-mode .right").html( "ON" ).removeClass( "hidden" );}
            else if( arrayStringa[37] == "255" )
                {$("#sub-stato .auto-mode").addClass( "hidden" );}
                
                
            $("#sub-stato .temperatura .right").html( arrayStringa[1] + " °C"  );
            
            if( arrayStringa[10] == "0" )
                {$("#sub-stato .ventilazione-1").addClass("hidden");}
            if( arrayStringa[17] == "0" )
                {$("#sub-stato .ventilazione-2").addClass("hidden");}
            if( arrayStringa[24] == "0" )
                {$("#sub-stato .ventilazione-3").addClass("hidden");}
            
            if( arrayStringa[12] == arrayStringa[15] )
                {$("#sub-stato .ventilazione-1 .right").html( "AUTO" );}
            else
                {$("#sub-stato .ventilazione-1 .right").html( $("#sub-info .ventilazioni.titolo span").html() + " " + arrayStringa[12] );}
            
            if( arrayStringa[19] == arrayStringa[22] )
                {$("#sub-stato .ventilazione-2 .right").html( "AUTO" );}
            else
                {$("#sub-stato .ventilazione-2 .right").html( $("#sub-info .ventilazioni.titolo span").html() + " " + arrayStringa[19] );}
            
            if( arrayStringa[26] == arrayStringa[29] )
                {$("#sub-stato .ventilazione-3 .right").html( "AUTO" );}
            else
                {$("#sub-stato .ventilazione-3 .right").html( $("#sub-info .ventilazioni.titolo span").html() + " " + arrayStringa[26] );}
            /*************************/
            
            
            /****** POTENZA PAGE *******/
            $("#sub-potenza .temperatura-rilevata .temperatura").html( arrayStringa[1] + "°" );
            $("#sub-potenza .temperatura-impostata .temperatura").html( (arrayStringa[4]) + "°"  );
            $("#sub-potenza .temperatura-impostata").attr( "value", arrayStringa[4] );
            $("#sub-potenza .temperatura-acqua-rilevata .temperatura").html( (arrayStringa[3]) + "°" );
            $("#sub-potenza .temperatura-acqua-impostata .temperatura-acqua").html( (arrayStringa[6]) + "°"  );
            $("#sub-potenza .temperatura-acqua-impostata").attr( "value", arrayStringa[6] );
            
            cambiaPotenza(arrayStringa[5]);
            
            $("#sub-potenza > div").removeClass("hidden");
                
            if( arrayStringa[31] == "0" && arrayStringa[32] == "0" ) // SE è ARIA
                {tipoStufa = 0; $("#sub-potenza .riga-acqua").addClass("hidden");}
            else // SE è HYDRO
                {tipoStufa = 1; $("#sub-potenza .riga-potenza").removeClass("hidden"); $('#sub-potenza .auto-mode').addClass("hidden");}
                
            if( arrayStringa[36] == "01" )
                {$("#sub-potenza .eco-stop .eco-on").trigger("click");}
            else if( arrayStringa[36] == "00" ) 
                {$("#sub-potenza .eco-stop .eco-off").trigger("click");}
            else if( arrayStringa[36] == "255" )
                {$("#sub-potenza .eco-stop > div").addClass("hidden");}
            
            if( arrayStringa[37] == "00" )
                {
                    $('#sub-potenza .auto-mode .auto-on').trigger("click");
                    $('#sub-potenza .riga-potenza').addClass("hidden");
                }
            else if( arrayStringa[37] == "01" )
                {
                    $('#sub-potenza .auto-mode .auto-off').trigger("click");
                    $("#sub-potenza .riga-ambiente").addClass("hidden");
                    $("#sub-potenza .riga-acqua").addClass("hidden");
                }
            else if( arrayStringa[37] == "255" )
                {
                    $('#sub-potenza .auto-mode').addClass("hidden");
                }
            /***************************/
            
                        
            /****** VENTILAZIONE PAGE *******/
            if( arrayStringa[10] == "0" )
                {$("#sub-ventilazione .ventilatore-1, #sub-ventilazione .titolo-ventilatore-1").addClass("hidden");}
            if( arrayStringa[17] == "0" )
                {$("#sub-ventilazione .ventilatore-2, #sub-ventilazione .titolo-ventilatore-2").addClass("hidden");}
            if( arrayStringa[24] == "0" )
                {$("#sub-ventilazione .ventilatore-3, #sub-ventilazione .titolo-ventilatore-3").addClass("hidden");}
            
            cambiaVentilazione(arrayStringa[13], arrayStringa[14], arrayStringa[12], arrayStringa[15], arrayStringa[11], arrayStringa[16], "ventilatore-1");
            cambiaVentilazione(arrayStringa[20], arrayStringa[21], arrayStringa[19], arrayStringa[22], arrayStringa[18], arrayStringa[23], "ventilatore-2");
            cambiaVentilazione(arrayStringa[27], arrayStringa[28], arrayStringa[26], arrayStringa[29], arrayStringa[25], arrayStringa[30], "ventilatore-3");
            /********************************/
            
            
            /****** INFO PAGE *******/
            if( arrayStringa[37] == "0" )
                {$("#sub-info .generale .right").html( "AUTO" );}
            else if( arrayStringa[0] == "4" /*|| arrayStringa[0] == "5"*/ )
                {$("#sub-info .generale .right").html( statoMacchinaLingua[arrayStringa[0]] + " " + arrayStringa[5] );}
            else
                {$("#sub-info .generale .right").html( statoMacchinaLingua[arrayStringa[0]] );}

            
            $("#sub-info .temperatura-impostata .right").html( (arrayStringa[4]) + " °C"  );
            $("#sub-info .temperatura-rilevata .right").html( arrayStringa[1] + " °C" );
            $("#sub-info .temperatura-fumi .right").html( arrayStringa[2] + " °C" );
            if( arrayStringa[10] == "0" )
                {$("#sub-info .ventilazione-principale").addClass("hidden");}
            if( arrayStringa[17] == "0" )
                {$("#sub-info .ventilazione-canalizzata1").addClass("hidden");}
            if( arrayStringa[24] == "0" )
                {$("#sub-info .ventilazione-canalizzata2").addClass("hidden");}
            
            if( arrayStringa[12] == arrayStringa[15] )
                {$("#sub-info .ventilazione-principale .right").html( "AUTO" );}
            else
                {$("#sub-info .ventilazione-principale .right").html( $("#sub-stato .ventilazione-1 .right").attr("title") + " " + arrayStringa[12] );}
            
            if( arrayStringa[19] == arrayStringa[22] )
                {$("#sub-info .ventilazione-canalizzata1 .right").html( "AUTO" );}
            else
                {$("#sub-info .ventilazione-canalizzata1 .right").html( $("#sub-stato .ventilazione-2 .right").attr("title") + " " + arrayStringa[19] );}
            
            if( arrayStringa[26] == arrayStringa[29] )
                {$("#sub-info .ventilazione-canalizzata2 .right").html( "AUTO" );}
            else
                {$("#sub-info .ventilazione-canalizzata2 .right").html( $("#sub-stato .ventilazione-3 .right").attr("title") + " " + arrayStringa[26] );}
            /************************/
                
            }
            $("#xLoader").hide(1);
    }).fail(function( xml ) {
        getStateTimeNext = 8000;
        erroreConnessione(alertLingua[10], 1);
        $("#xLoader").hide(1);
    });
}

function getDeviceInfo()
{
    statoGetDevice = 1;
    $("#xLoader").show(1);
    $.ajax({
        type: "GET",
        url: urlMicronova + "/GetDeviceInfo/" + customerCode + "|" + token + "|" + lastDispositivo[0],
        dataType: "xml",
        cache: false
    }).done(function( xml ) {
            $getData = $(xml).find( "GetDeviceInfoResult" );
            var risultato = $getData.text().trim();
        
            if(risultato == "65")
                {erroreConnessione(alertLingua[16], 1); getStateTimeNext = 8000;}
            else 
            {
            var arrayStringa = risultato.split("|");
            /****** STATO PAGE *******/
            
            
            /****** POTENZA PAGE *******/
            
            $("#sub-potenza .riga-potenza .potenze").attr( "min", arrayStringa[18] );
            $("#sub-potenza .riga-potenza .potenze").attr( "max", arrayStringa[19] );
            $("#sub-potenza .riga-ambiente .temperatura-impostata").attr( "min", arrayStringa[20] );
            $("#sub-potenza .riga-ambiente .temperatura-impostata").attr( "max", arrayStringa[21] );
            $("#sub-potenza .riga-acqua .temperatura-acqua-impostata").attr( "min", arrayStringa[22] );
            $("#sub-potenza .riga-acqua .temperatura-acqua-impostata").attr( "max", arrayStringa[23] );
                        
            /****** CHRONO PAGE *******/                
            for( var i = 1; i <= parseInt(arrayStringa[13]); i++ )
                {$("#sub-chrono #programma-" + i).removeClass("hidden");}

            statoGetDevice = 0;
            getToken("getState", "", "");
            }
    }).fail(function( xml ) {
        getStateTimeNext = 8000;
        erroreConnessione(alertLingua[10], 1);
        $("#xLoader").hide(1);
    });
}

function readChrono()
{
    //$("#xLoader").show(1);
    $.ajax({
        type: "GET",
        //url: url + "/readchrono.xml",
        url: urlMicronova + "/ReadChrono/" + customerCode + "|" + token + "|" + lastDispositivo[0],
        dataType: "xml",
        cache: false
    }).done(function( xml ) {
            $getData = $(xml).find( "ReadChronoResponse" );
            var risultato = $getData.text().trim();
        
            if(risultato == "65")
                {erroreConnessione(alertLingua[16], 0);}
            else if(risultato.length > 40) //Se ricevo una stringa con più di 50 caratteri
            {
                var arrayStringa = [];
                    for(var i = 0; i < risultato.length; i++)
                    {
                        arrayStringa[i/2] = parseInt(risultato.substring(i, i + 2), 16);
                        i++;
                    }

                var i = 0;
                $(".programma-chrono").each(function(e) {
                    var startOre = parseInt(arrayStringa[i + 0] / 6) * 6;
                    var startMinuti = arrayStringa[i + 0] % 6;
                    var stopOre = parseInt(arrayStringa[i + 1] / 6) * 6;
                    var stopMinuti = arrayStringa[i + 1] % 6;
                    var tempAmbiente = arrayStringa[i + 2];
                    var setPotenza = arrayStringa[i + 3];
                    var enable = arrayStringa[i + 5];
                    var days = "" + ConvertBase.dec2bin(arrayStringa[i + 6]); //console.log(days);
                    days = days.split("").reverse().join("");

                    $(this).find("#start select.ore").val(startOre).change();
                    $(this).find("#start select.minuti").val(startMinuti).change();
                    $(this).find("#stop select.ore").val(stopOre).change();
                    $(this).find("#stop select.minuti").val(stopMinuti).change();
                    $(this).find("#setTemperatura select").val(tempAmbiente).change();
                    $(this).find("#setPotenza select").val(setPotenza).change();
                    enable == 1 ? $(this).find(".abilita-chrono input").attr("checked", "true") : "";
                    for(var z = 0; z < days.length; z++)
                        {
                            if( days[z] == 1 )
                                {$(this).find(".giorno:nth-child(" + (z + 1) + ") > div").addClass("active");}
                            else
                                {$(this).find(".giorno:nth-child(" + (z + 1) + ") > div").removeClass("active");}
                        }
                    
                    if( tempAmbiente == parseInt(255) )
                        {$(this).find(".chrono-temperatura").addClass("hidden");}
                    if( setPotenza == parseInt(255) )
                        {$(this).find(".chrono-potenza").addClass("hidden");}
                    if( enable == parseInt(255) )
                        {$(this).find( ".abilita-chrono").addClass("hidden");}

                    i += 7;
                });
            }
            else
                {$(".div-alert .text").html( alertLingua[16] ).fadeIn(500).fadeOut(4000);}
            $("#xLoader").hide(1);
    }).fail(function( xml ) {
        erroreConnessione(alertLingua[10], 0);
        $("#xLoader").hide(1);
    });
}

function writeChrono()
{
    $("#xLoader").show(1);
    var stringa = "";
    $(".programma-chrono").each(function(e) {
        var start = parseInt( $(this).find("#start select.ore").val() ) + parseInt( $(this).find("#start select.minuti").val() );
        var stop = parseInt( $(this).find("#stop select.ore").val() ) + parseInt( $(this).find("#stop select.minuti").val() );
        var tempAmbiente = $(this).find("#setTemperatura select").val();
        var setPotenza = $(this).find("#setPotenza select").val();
        var enable = "";
        $(this).find(".abilita-chrono input").is(':checked') ? enable = "1" : enable = "0";
        
        var days = "";
        
        $(this).find(".giorno div").each(function(e) {
            if( $(this).hasClass("active") )
                {days += "1";}
            else
                {days += "0";}
        });
        days = "0" + days.split("").reverse().join("");
        days = ConvertBase.bin2dec(days);
        
        stringa += "|" + start + "|" + stop + "|" + tempAmbiente + "|" + setPotenza + "|FF|" + enable + "|" + days;
    });

    $.ajax({
        type: "GET",
        url: urlMicronova + "/WriteChrono/" + customerCode + "|" + token + "|" + lastDispositivo[0] + "" + stringa + "|1",
        dataType: "xml",
        cache: false
    }).done(function( xml ) {

        if(risultato == "01")
            {erroreConnessione(alertLingua[14], 0);}
        else if(risultato == "02")
            {erroreConnessione(alertLingua[15], 0);}
        else if(risultato == "65")
            {erroreConnessione(alertLingua[16], 0);}
        
        $("#xLoader").hide(1);        
    }).fail(function( xml ) {
        erroreConnessione(alertLingua[10], 0);
        $("#xLoader").hide(1);
    });
}

function compilaListaDispositivi()
{
    arrayDispositivi.sort();
    var elencoDispositivi = '';
    $.each( arrayDispositivi, function( i, val ) {
        elencoDispositivi += '<li mac="' + val[1] + '" cod-wifi="' + val[2] + '" cod-prodotto="' + val[3] + '" name="' + val[0] + '">';
        elencoDispositivi += '<div class="stove-img"><img width="100%" src="images/stove.png" /></div>';
        elencoDispositivi += '<div class="stove-name">' + val[0] + '</div>';
        elencoDispositivi += '<div class="stove-delete" mac="' + val[1] + '"><img width="100%" src="images/erase.png" /></div>';
        elencoDispositivi += '<div class="clear"></div>';
        elencoDispositivi += '</li>';

        if( val[1] == lastDispositivo[0] )
            {lastDispositivo[1] = val[0];}
    });
    
    if( arrayDispositivi.length == 0 )
    {
        $('.upage-content').addClass("hidden");
        $('.upage-content#sub-registra-prodotto').removeClass("hidden");
        $('.footer').addClass("fluidsoft-hidden");
        $('.header .first-header .stove-selected').addClass("hidden");
    }
    else
    {
        $('.upage-content#sub-stato').removeClass("hidden");
        $('.upage-content#sub-registra-prodotto').addClass("hidden");
        $('.footer').removeClass("fluidsoft-hidden");
        $('.header .first-header .stove-selected').removeClass("hidden");
        $('.header .first-header .stove-selected').html(lastDispositivo[1]);
    }
    $(".uib_w_13 .list-stove ul").html(elencoDispositivi);
    $("#sub-registra-prodotto input").val("");
}

function registerDevice(macAddress, regCode, artCode, serial, name)
{
    $("#xLoader").show(1);
    $.ajax({
        type: "GET",
        url: urlMicronova + "/RegisterDevice/" + customerCode + "|" + token + "|" + macAddress + "|" + regCode + "|" + artCode + "|serial|name",
        dataType: "xml",
        cache: false
        }).done(function( xml ) {
            $getData = $(xml).find( "RegisterDeviceResponse" );
            var risultato = $getData.text().trim();
            
            switch ( risultato ) {
            case "0":
                arrayDispositivi.push([name, macAddress, regCode, artCode]);
                lastDispositivo[0] = $("#sub-registra-prodotto .mac-address input").val();
                erroreConnessione(alertLingua[1], 0);
                compilaListaDispositivi();
                getToken("getDeviceInfo", "", "");
                break;
            case "2":
                arrayDispositivi.push([name, macAddress, regCode, artCode]);
                lastDispositivo[0] = $("#sub-registra-prodotto .mac-address input").val();
                erroreConnessione(alertLingua[3], 0);           
                compilaListaDispositivi();
                getToken("getDeviceInfo", "", "");
                break;
            case "1":
                erroreConnessione(alertLingua[2], 0);
                break;
            case "3":
                erroreConnessione(alertLingua[4], 0);
                break;
            case "4":
                erroreConnessione(alertLingua[5], 0);
                break;
            }
            writeDispositivi();
            $("#xLoader").hide(1);
        }).fail(function( xml ) {
            erroreConnessione(alertLingua[10], 0);
            $("#xLoader").hide(1);
        });
}

function recuperaLingua(lingua)
{   
    $("#xLoader").show(1);
    $.ajax({
        type: "GET",
        url: "./xml/language.xml",
        dataType: "xml",
        cache: false
    }).done(function( xml ) {
            $("#sub-stato .lista-stato .auto-mode .left").html( $(xml).find( lingua + " string[category='auto-mode']" ).text() );
            $("#sub-stato .lista-stato .stato .left").html( $(xml).find( lingua + " string[category='stato']" ).text() );
            //$("#sub-stato .lista-stato .auto-mode .right").html( $(xml).find( lingua + " string[category='manuale']" ).text() );
            $("#sub-stato .lista-stato .temperatura .left").html( $(xml).find( lingua + " string[category='t-ambiente']" ).text() );
            $("#sub-stato .lista-stato .ventilazione-1 .left").html( $(xml).find( lingua + " string[category='frontale']" ).text() );
            //$("#sub-stato .lista-stato .ventilazione-1 .right").html( $(xml).find( lingua + " string[category='ventilazione']" ).text() + " 3" );
            $("#sub-stato .lista-stato .ventilazione-1 .right").attr("title", $(xml).find( lingua + " string[category='ventilazione']" ).text() );
            $("#sub-stato .lista-stato .ventilazione-2 .left").html( $(xml).find( lingua + " string[category='canalizzata1']" ).text() );
            $("#sub-stato .lista-stato .ventilazione-2 .right").attr("title", $(xml).find( lingua + " string[category='ventilazione']" ).text() );
            //$("#sub-stato .lista-stato .ventilazione-2 .right").html( "AUTO" );
            $("#sub-stato .lista-stato .ventilazione-3 .left").html( $(xml).find( lingua + " string[category='canalizzata2']" ).text() );
            $("#sub-stato .lista-stato .ventilazione-3 .right").attr("title", $(xml).find( lingua + " string[category='ventilazione']" ).text() );
            //$("#sub-stato .lista-stato .ventilazione-3 .right").html( "AUTO" );
            $("#sub-stato .lista-stato .eco-stop .left").html( $(xml).find( lingua + " string[category='ecostop']" ).text() );
            
            $("#sub-potenza .auto-mode .title").html( $(xml).find( lingua + " string[category='auto-mode']" ).text() );
            $("#sub-potenza .seleziona-potenza .titolo").html( $(xml).find( lingua + " string[category='potenza']" ).text() );
            $("#sub-potenza .temperatura-impostata .titolo").html( $(xml).find( lingua + " string[category='t-impostata']" ).text() );
            $("#sub-potenza .temperatura-acqua-impostata .titolo").html( $(xml).find( lingua + " string[category='t-acqua-impostata']" ).text() );
            $("#sub-potenza .eco-stop .title").html( $(xml).find( lingua + " string[category='ecostop']" ).text() );
            
            $("#sub-ventilazione .frontale.titolo").html( $(xml).find( lingua + " string[category='frontale']" ).text() );
            $("#sub-ventilazione .canalizzata1.titolo").html( $(xml).find( lingua + " string[category='canalizzata1']" ).text() );
            $("#sub-ventilazione .canalizzata2.titolo").html( $(xml).find( lingua + " string[category='canalizzata2']" ).text() );
            
            $("#sub-chrono #programma-1 h4 a").html( $(xml).find( lingua + " string[category='programma1']" ).text() );
            $("#sub-chrono #programma-2 h4 a").html( $(xml).find( lingua + " string[category='programma2']" ).text() );
            $("#sub-chrono #programma-3 h4 a").html( $(xml).find( lingua + " string[category='programma3']" ).text() );
            $("#sub-chrono #programma-4 h4 a").html( $(xml).find( lingua + " string[category='programma4']" ).text() );
            $("#sub-chrono #programma-5 h4 a").html( $(xml).find( lingua + " string[category='programma5']" ).text() );
            $("#sub-chrono #programma-6 h4 a").html( $(xml).find( lingua + " string[category='programma6']" ).text() );
            $("#sub-chrono .programma-chrono .titolo.row1 .left").html( $(xml).find( lingua + " string[category='start']" ).text() );
            $("#sub-chrono .programma-chrono .titolo.row1 .right").html( $(xml).find( lingua + " string[category='stop']" ).text() );
            $("#sub-chrono .programma-chrono .titolo.row2 .left").html( $(xml).find( lingua + " string[category='t-ambiente']" ).text() );
            $("#sub-chrono .programma-chrono .titolo.row2 .right").html( $(xml).find( lingua + " string[category='potenza']" ).text() );
            $("#sub-chrono .programma-chrono .titolo.row3 .unica").html( $(xml).find( lingua + " string[category='giorni']" ).text() );
            $("#sub-chrono .invia-chrono").html( $(xml).find( lingua + " string[category='salva']" ).text() );
            
            $("#sub-info .generale.titolo span").html( $(xml).find( lingua + " string[category='generale']" ).text() );
            $("#sub-info .generale.lista-info .left").html( $(xml).find( lingua + " string[category='stato-attuale']" ).text() );
            //$("#sub-info .generale.lista-info .right").html( $(xml).find( lingua + " string[category='potenza']" ).text() + " 3" );
            $("#sub-info .temperature.titolo span").html( $(xml).find( lingua + " string[category='temperature']" ).text() );
            $("#sub-info .temperature .temperatura-impostata .left").html( $(xml).find( lingua + " string[category='t-impostata']" ).text() );
            $("#sub-info .temperature .temperatura-rilevata .left").html( $(xml).find( lingua + " string[category='t-ambiente']" ).text() );
            $("#sub-info .temperature .temperatura-fumi .left").html( $(xml).find( lingua + " string[category='t-fumi']" ).text() );
            $("#sub-info .ventilazioni.titolo span").html( $(xml).find( lingua + " string[category='ventilazione']" ).text() );
            $("#sub-info .ventilazioni .ventilazione-principale .left").html( $(xml).find( lingua + " string[category='frontale']" ).text() );
            //$("#sub-info .ventilazioni .ventilazione-principale .right").html( $(xml).find( lingua + " string[category='ventilazione']" ).text() + " 3" );            
            $("#sub-info .ventilazioni .ventilazione-canalizzata1 .left").html( $(xml).find( lingua + " string[category='canalizzata1']" ).text() );
            //$("#sub-info .ventilazioni .ventilazione-canalizzata1 .right").html( $(xml).find( lingua + " string[category='canalizzata1']" ).text() );
            $("#sub-info .ventilazioni .ventilazione-canalizzata2 .left").html( $(xml).find( lingua + " string[category='canalizzata2']" ).text() );
            //$("#sub-info .ventilazioni .ventilazione-canalizzata2 .right").html( $(xml).find( lingua + " string[category='canalizzata2']" ).text() );
            
            $("#sub-registra-prodotto .mac-address label").html( $(xml).find( lingua + " string[category='mac-address']" ).text() );
            //$("#sub-registra-prodotto .mac-address input").attr("placeholder", $(xml).find( lingua + " string[category='mac-address-placeholder']" ).text() );
            $("#sub-registra-prodotto .codice-wifi label").html( $(xml).find( lingua + " string[category='cod-wifi']" ).text() );
            //$("#sub-registra-prodotto .codice-wifi input").attr("placeholder", $(xml).find( lingua + " string[category='cod-wifi-placeholder']" ).text() );
            $("#sub-registra-prodotto .codice-articolo label").html( $(xml).find( lingua + " string[category='cod-articolo']" ).text() );
            //$("#sub-registra-prodotto .codice-articolo input").attr("placeholder", $(xml).find( lingua + " string[category='cod-articolo-placeholder']" ).text() );
            $("#sub-registra-prodotto .sn-prodotto label").html( $(xml).find( lingua + " string[category='sn-prodotto']" ).text() );
            //$("#sub-registra-prodotto .sn-prodotto input").attr("placeholder", $(xml).find( lingua + " string[category='sn-prodotto-placeholder']" ).text() );
            $("#sub-registra-prodotto .nome-prodotto label").html( $(xml).find( lingua + " string[category='nome-prodotto']" ).text() );
            $("#sub-registra-prodotto .nome-prodotto input").attr("placeholder", $(xml).find( lingua + " string[category='nome-prodotto-placeholder']" ).text() );
            $("#sub-registra-prodotto .registra-prodotto-button").html( $(xml).find( lingua + " string[category='registra-prodotto']" ).text() );
            
            $(".rightbar .account .lingua-label font").html( $(xml).find( lingua + " string[category='seleziona-lingua']" ).text() );
            $(".rightbar .list-stove .titolo").html( $(xml).find( lingua + " string[category='elenco-dispositivi']" ).text() );
            $(".rightbar .aggiungi-dispositivo div").html( $(xml).find( lingua + " string[category='aggiungi-dispositivo']" ).text() );
            
            statoMacchinaLingua = [$(xml).find( lingua + " string[category='stato-off']" ).text(),
                                   $(xml).find( lingua + " string[category='stato-carico-pellet']" ).text(),
                                   $(xml).find( lingua + " string[category='stato-attesa-fiamma']" ).text(),
                                   $(xml).find( lingua + " string[category='stato-acensione']" ).text(),
                                   $(xml).find( lingua + " string[category='potenza']" ).text(),
                                   $(xml).find( lingua + " string[category='potenza']" ).text(),
                                   $(xml).find( lingua + " string[category='stato-pulizia-braciere']" ).text(),
                                   $(xml).find( lingua + " string[category='stato-ecostop']" ).text(),
                                   $(xml).find( lingua + " string[category='stato-allarme']" ).text(),
                                   $(xml).find( lingua + " string[category='stato-memoria-allarme']" ).text()
                                  ];
            alertLingua = [$(xml).find( lingua + " string[category='alert-exit-app']" ).text(),
                           $(xml).find( lingua + " string[category='alert-registrazione-completata']" ).text(),
                           $(xml).find( lingua + " string[category='alert-registrazione-non-completata']" ).text(),
                           $(xml).find( lingua + " string[category='alert-registrazione-gia-effettuata']" ).text(),
                           $(xml).find( lingua + " string[category='alert-codice-wifi-non-trovato']" ).text(),
                           $(xml).find( lingua + " string[category='alert-codice-articolo-non-trovato']" ).text(),
                           $(xml).find( lingua + " string[category='alert-errore-recupero-dispositivi']" ).text(),
                           $(xml).find( lingua + " string[category='alert-errore-save-dispositivi']" ).text(),
                           $(xml).find( lingua + " string[category='alert-tutti-campi-obbligatori']" ).text(),
                           $(xml).find( lingua + " string[category='alert-dispositivo-non-trovato']" ).text(),
                           $(xml).find( lingua + " string[category='alert-server']" ).text(), //10
                           $(xml).find( lingua + " string[category='errore-recupero-token']" ).text(), //11
                           $(xml).find( lingua + " string[category='errore-di-scrittura']" ).text(), //12
                           $(xml).find( lingua + " string[category='errore-parametro-non-gestito']" ).text(), //13
                           $(xml).find( lingua + " string[category='errore-invio-dati']" ).text(), //14
                           $(xml).find( lingua + " string[category='errore-nessun-dato-chrono']" ).text(), //15
                           $(xml).find( lingua + " string[category='alert-dispositivo-non-connesso']" ).text() //16
                          ];
            $("#xLoader").hide(1);
            /*if( lastDispositivo[0] != "" )
                {}
            else
                {$("#xLoader").hide(1);}*/ //Se non ho dispositivi installati allora tolgo il loader
    }).fail(function( xml ) {
            erroreConnessione("Error Load Text", 1);
            $("#xLoader").hide(1);
    });
}
        
function readPersonalData()
{
    requestFileSystem(LocalFileSystem.PERSISTENT, 0, personalDataSuccess, personalDataError);
}
        
function personalDataSuccess(fileSystem) 
{   
    var directoryEntry = fileSystem.root;

    directoryEntry.getFile("personal-data.txt", {create: true, exclusive: false}, function(fileEntry){
        
        fileEntry.file(function(file){
            var reader = new FileReader();
            reader.onloadend = function (evt) {
                
                $(evt.target.result).find("Dispositivo").each(function() {
                    arrayDispositivi.push([$(this).find( "string[category='nome']" ).text(),
                                           $(this).find( "string[category='mac']" ).text(),
                                           $(this).find( "string[category='cod-wifi']" ).text(),
                                           $(this).find( "string[category='cod-articolo']" ).text()]);
                });
                
                languageUser = $(evt.target.result).find( "string[category='language']" ).text();
                if( languageUser == "" || languageUser == "undefined" ) 
                {
                    switch( navigator.language )
                    {
                        case "it-IT":
                            languageUser = "it";
                            break;
                        case "en-EN":
                            languageUser = "en";
                            break;
                        case "de-DE":
                            languageUser = "de";
                            break;
                        case "fr-FR":
                            languageUser = "fr";
                            break;
                        case "es-ES":
                            languageUser = "es";
                            break;
                        default:
                            languageUser = "en";
                    }
                }
                //$(".language option[value='" + languageUser + "']").attr('selected','selected');
                $(".lingua").html( $(".elenco-lingua ." + languageUser).html() );
                //recuperaLingua(languageUser);
                
                lastDispositivo[0] = $(evt.target.result).find( "string[category='lastDispositivo']" ).text();
                
                compilaListaDispositivi();
                recuperaLingua(languageUser);
                if( lastDispositivo[0] != "")
                    {getToken("getDeviceInfo", "", ""); }
            };
            //to read the content as binary use readAsArrayBuffer function.
            reader.readAsText(file);
            
        }, function(error){
            erroreConnessione("Error occurred while readline file. Error code is: " + error.code, 1);
        });

    }, function(error) {
        erroreConnessione("Error occurred while getting a pointer to file. Error code is: " + error.code, 1);
    });
}
        
function personalDataError(evt)
{erroreConnessione("Error occurred during request to file system pointer. Error code is: " + error.code, 1);}


function writeDispositivi() 
{window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, recuperoFile, erroreFile);}

function erroreFile() 
{erroreConnessione(alertLingua[6], 1);}

function recuperoFile(fileSystem) {
    fileSystem.root.getFile("personal-data.txt", {create: true, exclusive: false}, scrivoFile);
}

function scrivoFile(fileEntry) {
    fileEntry.createWriter(function(fileWriter){
        
        var fileContent = '<LinguaSelezionata><string category="language">' + languageUser + '</string></LinguaSelezionata>';
        fileContent += '<DispositivoSelezionato><string category="lastDispositivo">' + lastDispositivo[0] + '</string></DispositivoSelezionato>';
        
        if(arrayDispositivi.length > 0)
            {
            $.each( arrayDispositivi, function( i, val ) {
                    fileContent += '<ListaDispositivi><Dispositivo>';
                    fileContent += '<string category="mac">' + val[1] + '</string>';
                    fileContent += '<string category="cod-wifi">' + val[2] + '</string>';
                    fileContent += '<string category="cod-articolo">' + val[3] + '</string>';
                    fileContent += '<string category="nome">' + val[0] + '</string>';
                    fileContent += '</Dispositivo></ListaDispositivi>';
            });
            }
        //fileWriter.seek(fileWriter.length);
        fileWriter.write( fileContent );
    }, function(error){
        erroreConnessione(alertLingua[6], 1);
    });
}


/*
document.addEventListener("deviceready", onDeviceReady, false);

function onDeviceReady() {
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotDir, fail);
}

function gotFS(fileSystem) {
   fileSystem.root.getDirectory("FluidsoftExample", {create: true}, gotDir);
    console.log("Directory creata");
}

function fail() {
   alert("non va un cazzo");
}

function gotDir(fileSystem) {
    fileSystem.root.getFile("personal-data.txt", {create: true, exclusive: false}, gotFile);
}

function gotFile(fileEntry) {
    fileEntry.createWriter(function(fileWriter){
                    fileWriter.seek(fileWriter.length);
                    fileWriter.write( '<?xml version="1.0" encoding="UTF-8" xmlns="http://tempuri.org/"><ListaDispositivi><Dispositivo id="0"><string category="mac">01:02:03:04:FF:00</string><string category="cod-wifi">213456</string><string category="cod-articolo">753654</string><string category="nome">Stufa Casa Montagna</string></Dispositivo></ListaDispositivi>' );
                    alert("File scritto nella directory: " + cordova.file.dataDirectory);
                }, function(error){
                    alert("Write Error: " + error.code);
                });
}*/
/*
document.addEventListener("deviceready", onDeviceReady, false);
        
        function onDeviceReady() 
        {
            requestFileSystem(LocalFileSystem.PERSISTENT, 0, onSuccess, onError);
        }
        
        function onSuccess(fileSystem) 
        {   
            var directoryEntry = fileSystem.root;
            
            //object to read the contents of the directory
            var directoryReader = directoryEntry.createReader();
            
            //now read the contents using the readEntries function.
            directoryReader.readEntries(function(entries){
                var i;
                for (i=0; i<entries.length; i++) 
                {
                    console.log(entries[i].name);
                }
            },function(error){
                console.log("Failed to list directory contents. Error code is: " + error.code);
            });
        }
        
        function onError(evt)
        {
            console.log("Error occurred during request to file system pointer. Error code is: " + evt.code);
        }
*/